diff --git a/Documentation/devicetree/bindings/input/rotary-encoder.txt b/Documentation/devicetree/bindings/input/rotary-encoder.txt
deleted file mode 100644
index a644408b33b8..000000000000
--- a/Documentation/devicetree/bindings/input/rotary-encoder.txt
+++ /dev/null
@@ -1,50 +0,0 @@
-Rotary encoder DT bindings
-
-Required properties:
-- gpios: a spec for at least two GPIOs to be used, most significant first
-
-Optional properties:
-- linux,axis: the input subsystem axis to map to this rotary encoder.
-  Defaults to 0 (ABS_X / REL_X)
-- rotary-encoder,steps: Number of steps in a full turnaround of the
-  encoder. Only relevant for absolute axis. Defaults to 24 which is a
-  typical value for such devices.
-- rotary-encoder,relative-axis: register a relative axis rather than an
-  absolute one. Relative axis will only generate +1/-1 events on the input
-  device, hence no steps need to be passed.
-- rotary-encoder,rollover: Automatic rollover when the rotary value becomes
-  greater than the specified steps or smaller than 0. For absolute axis only.
-- rotary-encoder,steps-per-period: Number of steps (stable states) per period.
-  The values have the following meaning:
-  1: Full-period mode (default)
-  2: Half-period mode
-  4: Quarter-period mode
-- wakeup-source: Boolean, rotary encoder can wake up the system.
-- rotary-encoder,encoding: String, the method used to encode steps.
-  Supported are "gray" (the default and more common) and "binary".
-
-Deprecated properties:
-- rotary-encoder,half-period: Makes the driver work on half-period mode.
-  This property is deprecated. Instead, a 'steps-per-period ' value should
-  be used, such as "rotary-encoder,steps-per-period = <2>".
-
-See Documentation/input/devices/rotary-encoder.rst for more information.
-
-Example:
-
-		rotary@0 {
-			compatible = "rotary-encoder";
-			gpios = <&gpio 19 1>, <&gpio 20 0>; /* GPIO19 is inverted */
-			linux,axis = <0>; /* REL_X */
-			rotary-encoder,encoding = "gray";
-			rotary-encoder,relative-axis;
-		};
-
-		rotary@1 {
-			compatible = "rotary-encoder";
-			gpios = <&gpio 21 0>, <&gpio 22 0>;
-			linux,axis = <1>; /* ABS_Y */
-			rotary-encoder,steps = <24>;
-			rotary-encoder,encoding = "binary";
-			rotary-encoder,rollover;
-		};
diff --git a/Documentation/devicetree/bindings/input/rotary-encoder.yaml b/Documentation/devicetree/bindings/input/rotary-encoder.yaml
new file mode 100644
index 000000000000..5b60ea86bd62
--- /dev/null
+++ b/Documentation/devicetree/bindings/input/rotary-encoder.yaml
@@ -0,0 +1,100 @@
+# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
+%YAML 1.2
+---
+$id: http://devicetree.org/schemas/input/rotary-encoder.yaml#
+$schema: http://devicetree.org/meta-schemas/core.yaml#
+
+title: Generic Rotary Encoder
+
+maintainers:
+  - Dmitry Torokhov <dmitry.torokhov@gmail.com>
+
+description:
+  See Documentation/input/devices/rotary-encoder.rst for more information.
+
+properties:
+  compatible:
+    const: rotary-encoder
+
+  gpios:
+    minItems: 2
+    description: GPIOs for the rotation signals, most significant first
+
+  linux,axis:
+    description:
+      The input subsystem axis to map to this rotary encoder.
+      Defaults to (ABS_X / REL_X).
+    $ref: /schemas/types.yaml#/definitions/uint32
+    default: 0
+
+  rotary-encoder,rollover:
+    description:
+      Automatic rollover when the rotary value becomes greater than the
+      specified steps or smaller than 0. For absolute axis only.
+    type: boolean
+
+  rotary-encoder,steps-per-period:
+    description: The values have the following meaning
+      1 - Full-period mode
+      2 - Half-period mode
+      4 - Quarter-period mode
+    $ref: /schemas/types.yaml#/definitions/uint32
+    enum: [1, 2, 4]
+    default: 1
+
+  wakeup-source:
+    description: Rotary encoder can wake up the system.
+    type: boolean
+
+  rotary-encoder,encoding:
+    description:
+      Method used to encode steps. Gray code is more common.
+    $ref: /schemas/types.yaml#/definitions/string
+    enum: ["gray", "binary"]
+    default: "gray"
+
+  rotary-encoder,half-period:
+    description:
+      Deprecated, use "rotary-encoder,steps-per-period = <2>" instead.
+    type: boolean
+    deprecated: True
+
+  rotary-encoder,steps:
+    description:
+      Number of steps in a full turnaround of the encoder. Only relevant
+      for absolute axis. Defaults to 24 which is a typical value for such
+      devices.
+    $ref: /schemas/types.yaml#/definitions/uint32
+    default: 24
+
+  rotary-encoder,relative-axis:
+    description:
+      register a relative axis rather than an absolute one. Relative axis
+      will only generate +1/-1 events on the input device, hence no steps
+      need to be passed.
+    type: boolean
+
+required:
+  - compatible
+  - gpios
+
+additionalProperties: false
+
+examples:
+  - |
+    #include "dt-bindings/gpio/gpio.h"
+    #include "dt-bindings/input/input.h"
+    rotary-encoder0 {
+            compatible = "rotary-encoder";
+            gpios = <&gpio 19 GPIO_ACTIVE_LOW>, <&gpio 20 GPIO_ACTIVE_HIGH>;
+            linux,axis = <REL_X>;
+            rotary-encoder,encoding = "gray";
+            rotary-encoder,relative-axis;
+    };
+    rotary-encoder1 {
+            compatible = "rotary-encoder";
+            gpios = <&gpio 21 GPIO_ACTIVE_HIGH>, <&gpio 22 GPIO_ACTIVE_HIGH>;
+            linux,axis = <ABS_Y>;
+            rotary-encoder,encoding = "binary";
+            rotary-encoder,rollover;
+    };