diff --git a/Documentation/devicetree/bindings/input/elan_i2c.txt b/Documentation/devicetree/bindings/input/elan_i2c.txt
index 9963247..f11c8e1 100644
--- a/Documentation/devicetree/bindings/input/elan_i2c.txt
+++ b/Documentation/devicetree/bindings/input/elan_i2c.txt
@@ -26,7 +26,7 @@ Optional properties:

 [0]: Documentation/devicetree/bindings/interrupt-controller/interrupts.txt
 [1]: Documentation/devicetree/bindings/pinctrl/pinctrl-bindings.txt
-[2]: Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt
+[2]: Documentation/devicetree/bindings/input/touchscreen.txt

 Example:
 	&i2c1 {
diff --git a/Documentation/devicetree/bindings/input/touchscreen.txt b/Documentation/devicetree/bindings/input/touchscreen.txt
new file mode 100644
index 0000000..e1adb90
--- /dev/null
+++ b/Documentation/devicetree/bindings/input/touchscreen.txt
@@ -0,0 +1 @@
+See touchscreen.yaml
diff --git a/Documentation/devicetree/bindings/input/touchscreen.yaml b/Documentation/devicetree/bindings/input/touchscreen.yaml
new file mode 100644
index 0000000..e2e27c3
--- /dev/null
+++ b/Documentation/devicetree/bindings/input/touchscreen.yaml
@@ -0,0 +1,83 @@
+# SPDX-License-Identifier: GPL-2.0
+%YAML 1.2
+---
+$id: http://devicetree.org/schemas/input/touchscreen.yaml#
+$schema: http://devicetree.org/meta-schemas/core.yaml#
+
+title: Common touchscreen Bindings
+
+maintainers:
+  - Dmitry Torokhov <dmitry.torokhov@gmail.com>
+
+properties:
+  touchscreen-min-x:
+    description: minimum x coordinate reported
+    $ref: /schemas/types.yaml#/definitions/uint32
+    default: 0
+
+  touchscreen-min-y:
+    description: minimum y coordinate reported
+    $ref: /schemas/types.yaml#/definitions/uint32
+    default: 0
+
+  touchscreen-size-x:
+    description: horizontal resolution of touchscreen (maximum x coordinate reported + 1)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-size-y:
+    description: vertical resolution of touchscreen (maximum y coordinate reported + 1)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-max-pressure:
+    description: maximum reported pressure (arbitrary range dependent on the controller)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-min-pressure:
+    description: minimum pressure on the touchscreen to be achieved in order
+      for the touchscreen driver to report a touch event.
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-fuzz-x:
+    description: horizontal noise value of the absolute input device (in pixels)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-fuzz-y:
+    description: vertical noise value of the absolute input device (in pixels)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-fuzz-pressure:
+    description: pressure noise value of the absolute input device (arbitrary
+      range dependent on the controller)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-average-samples:
+    description: Number of data samples which are averaged for each read (valid
+      values dependent on the controller)
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-inverted-x:
+    description: X axis is inverted
+    type: boolean
+
+  touchscreen-inverted-y:
+    description: Y axis is inverted
+    type: boolean
+
+  touchscreen-swapped-x-y:
+    description: X and Y axis are swapped
+                 Swapping is done after inverting the axis
+    type: boolean
+
+  touchscreen-x-mm:
+    description: horizontal length in mm of the touchscreen
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+  touchscreen-y-mm:
+    description: vertical length in mm of the touchscreen
+    $ref: /schemas/types.yaml#/definitions/uint32
+
+dependencies:
+  touchscreen-size-x: [ touchscreen-size-y ]
+  touchscreen-size-y: [ touchscreen-size-x ]
+  touchscreen-x-mm: [ touchscreen-y-mm ]
+  touchscreen-y-mm: [ touchscreen-x-mm ]
diff --git a/Documentation/devicetree/bindings/input/touchscreen/ads7846.txt b/Documentation/devicetree/bindings/input/touchscreen/ads7846.txt
index 81f6bda..b158a86 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/ads7846.txt
+++ b/Documentation/devicetree/bindings/input/touchscreen/ads7846.txt
@@ -69,7 +69,7 @@ Optional properties:
 	touchscreen-swapped-x-y		General touchscreen binding, see [1].

 [1] All general touchscreen properties are described in
-    Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt.
+    Documentation/devicetree/bindings/input/touchscreen.txt.

 Deprecated properties:

diff --git a/Documentation/devicetree/bindings/input/touchscreen/bu21013.txt b/Documentation/devicetree/bindings/input/touchscreen/bu21013.txt
index da4c9d8..e056a5f 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/bu21013.txt
+++ b/Documentation/devicetree/bindings/input/touchscreen/bu21013.txt
@@ -17,7 +17,7 @@ Optional properties:
  - touchscreen-swapped-x-y : General touchscreen binding, see [1].

 [1] All general touchscreen properties are described in
-    Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt.
+    Documentation/devicetree/bindings/input/touchscreen.txt.

 Deprecated properties:
  - rohm,touch-max-x        : Maximum outward permitted limit in the X axis
diff --git a/Documentation/devicetree/bindings/input/touchscreen/cypress,cy8ctma140.yaml b/Documentation/devicetree/bindings/input/touchscreen/cypress,cy8ctma140.yaml
index 3225c8d..900e112 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/cypress,cy8ctma140.yaml
+++ b/Documentation/devicetree/bindings/input/touchscreen/cypress,cy8ctma140.yaml
@@ -10,7 +10,7 @@ maintainers:
   - Linus Walleij <linus.walleij@linaro.org>

 allOf:
-  - $ref: touchscreen.yaml#
+  - $ref: ../touchscreen.yaml#

 properties:
   compatible:
diff --git a/Documentation/devicetree/bindings/input/touchscreen/edt-ft5x06.yaml b/Documentation/devicetree/bindings/input/touchscreen/edt-ft5x06.yaml
index 4ce1094..3d73fe3 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/edt-ft5x06.yaml
+++ b/Documentation/devicetree/bindings/input/touchscreen/edt-ft5x06.yaml
@@ -18,7 +18,7 @@ maintainers:
   - Dmitry Torokhov <dmitry.torokhov@gmail.com>

 allOf:
-  - $ref: touchscreen.yaml#
+  - $ref: ../touchscreen.yaml#
   - if:
       properties:
         compatible:
diff --git a/Documentation/devicetree/bindings/input/touchscreen/eeti,exc3000.yaml b/Documentation/devicetree/bindings/input/touchscreen/eeti,exc3000.yaml
index 007adbc..b1beb61 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/eeti,exc3000.yaml
+++ b/Documentation/devicetree/bindings/input/touchscreen/eeti,exc3000.yaml
@@ -10,7 +10,7 @@ maintainers:
   - Dmitry Torokhov <dmitry.torokhov@gmail.com>

 allOf:
-  - $ref: touchscreen.yaml#
+  - $ref: ../touchscreen.yaml#

 properties:
   compatible:
diff --git a/Documentation/devicetree/bindings/input/touchscreen/elan,elants_i2c.yaml b/Documentation/devicetree/bindings/input/touchscreen/elan,elants_i2c.yaml
index a792d63..d3fabaf 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/elan,elants_i2c.yaml
+++ b/Documentation/devicetree/bindings/input/touchscreen/elan,elants_i2c.yaml
@@ -10,7 +10,7 @@ maintainers:
   - David Heidelberg <david@ixit.cz>

 allOf:
-  - $ref: touchscreen.yaml#
+  - $ref: ../touchscreen.yaml#

 properties:
   compatible:
diff --git a/Documentation/devicetree/bindings/input/touchscreen/goodix.yaml b/Documentation/devicetree/bindings/input/touchscreen/goodix.yaml
index da5b0d8..5bea19a 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/goodix.yaml
+++ b/Documentation/devicetree/bindings/input/touchscreen/goodix.yaml
@@ -10,7 +10,7 @@ maintainers:
   - Dmitry Torokhov <dmitry.torokhov@gmail.com>

 allOf:
-  - $ref: touchscreen.yaml#
+  - $ref: ../touchscreen.yaml#

 properties:
   compatible:
diff --git a/Documentation/devicetree/bindings/input/touchscreen/iqs5xx.txt b/Documentation/devicetree/bindings/input/touchscreen/iqs5xx.txt
index efa0820..d9c107e 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/iqs5xx.txt
+++ b/Documentation/devicetree/bindings/input/touchscreen/iqs5xx.txt
@@ -56,7 +56,7 @@ Optional properties:

 [0]: Documentation/devicetree/bindings/interrupt-controller/interrupts.txt
 [1]: Documentation/devicetree/bindings/gpio/gpio.txt
-[2]: Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt
+[2]: Documentation/devicetree/bindings/input/touchscreen.txt

 Example:

diff --git a/Documentation/devicetree/bindings/input/touchscreen/mms114.txt b/Documentation/devicetree/bindings/input/touchscreen/mms114.txt
index 707234c..4c28a30 100644
--- a/Documentation/devicetree/bindings/input/touchscreen/mms114.txt
+++ b/Documentation/devicetree/bindings/input/touchscreen/mms114.txt
@@ -18,7 +18,7 @@ Optional properties:
 - touchscreen-inverted-y: See [1]
 - touchscreen-swapped-x-y: See [1]

-[1]: Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt
+[1]: Documentation/devicetree/bindings/input/touchscreen.txt

 Example:

diff --git a/Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt b/Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt
deleted file mode 100644
index e1adb90..0000000
--- a/Documentation/devicetree/bindings/input/touchscreen/touchscreen.txt
+++ /dev/null
@@ -1 +0,0 @@
-See touchscreen.yaml
diff --git a/Documentation/devicetree/bindings/input/touchscreen/touchscreen.yaml b/Documentation/devicetree/bindings/input/touchscreen/touchscreen.yaml
deleted file mode 100644
index 36dc7b5..0000000
--- a/Documentation/devicetree/bindings/input/touchscreen/touchscreen.yaml
+++ /dev/null
@@ -1,83 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0
-%YAML 1.2
----
-$id: http://devicetree.org/schemas/input/touchscreen/touchscreen.yaml#
-$schema: http://devicetree.org/meta-schemas/core.yaml#
-
-title: Common touchscreen Bindings
-
-maintainers:
-  - Dmitry Torokhov <dmitry.torokhov@gmail.com>
-
-properties:
-  touchscreen-min-x:
-    description: minimum x coordinate reported
-    $ref: /schemas/types.yaml#/definitions/uint32
-    default: 0
-
-  touchscreen-min-y:
-    description: minimum y coordinate reported
-    $ref: /schemas/types.yaml#/definitions/uint32
-    default: 0
-
-  touchscreen-size-x:
-    description: horizontal resolution of touchscreen (maximum x coordinate reported + 1)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-size-y:
-    description: vertical resolution of touchscreen (maximum y coordinate reported + 1)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-max-pressure:
-    description: maximum reported pressure (arbitrary range dependent on the controller)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-min-pressure:
-    description: minimum pressure on the touchscreen to be achieved in order
-      for the touchscreen driver to report a touch event.
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-fuzz-x:
-    description: horizontal noise value of the absolute input device (in pixels)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-fuzz-y:
-    description: vertical noise value of the absolute input device (in pixels)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-fuzz-pressure:
-    description: pressure noise value of the absolute input device (arbitrary
-      range dependent on the controller)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-average-samples:
-    description: Number of data samples which are averaged for each read (valid
-      values dependent on the controller)
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-inverted-x:
-    description: X axis is inverted
-    type: boolean
-
-  touchscreen-inverted-y:
-    description: Y axis is inverted
-    type: boolean
-
-  touchscreen-swapped-x-y:
-    description: X and Y axis are swapped
-                 Swapping is done after inverting the axis
-    type: boolean
-
-  touchscreen-x-mm:
-    description: horizontal length in mm of the touchscreen
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-  touchscreen-y-mm:
-    description: vertical length in mm of the touchscreen
-    $ref: /schemas/types.yaml#/definitions/uint32
-
-dependencies:
-  touchscreen-size-x: [ touchscreen-size-y ]
-  touchscreen-size-y: [ touchscreen-size-x ]
-  touchscreen-x-mm: [ touchscreen-y-mm ]
-  touchscreen-y-mm: [ touchscreen-x-mm ]