diff --git a/Documentation/devicetree/bindings/input/azoteq,iqs7222.yaml b/Documentation/devicetree/bindings/input/azoteq,iqs7222.yaml
index 9ddba7f2e7aa..f2382a56884d 100644
--- a/Documentation/devicetree/bindings/input/azoteq,iqs7222.yaml
+++ b/Documentation/devicetree/bindings/input/azoteq,iqs7222.yaml
@@ -354,10 +354,11 @@ patternProperties:
         description: Specifies the channel's ATI target.
 
       azoteq,ati-base:
-        $ref: /schemas/types.yaml#/definitions/uint32
-        multipleOf: 16
-        minimum: 0
-        maximum: 496
+        $ref: /schemas/types.yaml#/definitions/uint32-array
+        items:
+          - multipleOf: 16
+            minimum: 0
+            maximum: 496
         description: Specifies the channel's ATI base.
 
       azoteq,ati-mode:
@@ -440,7 +441,8 @@ patternProperties:
               slider gesture).
 
           azoteq,thresh:
-            $ref: /schemas/types.yaml#/definitions/uint32
+            $ref: /schemas/types.yaml#/definitions/uint32-array
+            maxItems: 1
             description:
               Specifies the threshold for the event. Valid entries range from
               0-127 and 0-255 for proximity and touch events, respectively.
diff --git a/Documentation/devicetree/bindings/input/iqs269a.yaml b/Documentation/devicetree/bindings/input/iqs269a.yaml
index 3c430d38594f..4fa20f0f6847 100644
--- a/Documentation/devicetree/bindings/input/iqs269a.yaml
+++ b/Documentation/devicetree/bindings/input/iqs269a.yaml
@@ -334,9 +334,10 @@ patternProperties:
           3: Full
 
       azoteq,ati-base:
-        $ref: /schemas/types.yaml#/definitions/uint32
-        enum: [75, 100, 150, 200]
-        default: 100
+        $ref: /schemas/types.yaml#/definitions/uint32-array
+        items:
+          - enum: [75, 100, 150, 200]
+            default: 100
         description: Specifies the channel's ATI base.
 
       azoteq,ati-target:
@@ -391,10 +392,11 @@ patternProperties:
 
         properties:
           azoteq,thresh:
-            $ref: /schemas/types.yaml#/definitions/uint32
-            minimum: 0
-            maximum: 255
-            default: 10
+            $ref: /schemas/types.yaml#/definitions/uint32-array
+            items:
+              - minimum: 0
+                maximum: 255
+                default: 10
             description: Specifies the threshold for the event.
 
           linux,code: true
@@ -408,10 +410,11 @@ patternProperties:
 
         properties:
           azoteq,thresh:
-            $ref: /schemas/types.yaml#/definitions/uint32
-            minimum: 0
-            maximum: 255
-            default: 8
+            $ref: /schemas/types.yaml#/definitions/uint32-array
+            items:
+              - minimum: 0
+                maximum: 255
+                default: 8
             description: Specifies the threshold for the event.
 
           azoteq,hyst:
@@ -432,10 +435,11 @@ patternProperties:
 
         properties:
           azoteq,thresh:
-            $ref: /schemas/types.yaml#/definitions/uint32
-            minimum: 0
-            maximum: 255
-            default: 26
+            $ref: /schemas/types.yaml#/definitions/uint32-array
+            items:
+              - minimum: 0
+                maximum: 255
+                default: 26
             description: Specifies the threshold for the event.
 
           azoteq,hyst:
diff --git a/Documentation/devicetree/bindings/input/iqs626a.yaml b/Documentation/devicetree/bindings/input/iqs626a.yaml
index 7a27502095f3..dbd63d48605c 100644
--- a/Documentation/devicetree/bindings/input/iqs626a.yaml
+++ b/Documentation/devicetree/bindings/input/iqs626a.yaml
@@ -234,8 +234,9 @@ patternProperties:
           about the available RUI options.
 
       azoteq,ati-base:
-        $ref: /schemas/types.yaml#/definitions/uint32
-        enum: [75, 100, 150, 200]
+        $ref: /schemas/types.yaml#/definitions/uint32-array
+        items:
+          - enum: [75, 100, 150, 200]
         description:
           Specifies the channel's ATI base. The default value is a function
           of the channel and the device's RUI.
@@ -475,9 +476,10 @@ patternProperties:
 
         properties:
           azoteq,thresh:
-            $ref: /schemas/types.yaml#/definitions/uint32
-            minimum: 0
-            maximum: 255
+            $ref: /schemas/types.yaml#/definitions/uint32-array
+            items:
+              - minimum: 0
+                maximum: 255
             description: Specifies the threshold for the event.
 
           azoteq,hyst: